module AdvancedDCL
  module Arrow
    def param_init
      @param = Parameter.new(Common.param)
      @param.init("lprop", TrueClass, "sglset", "sglget", 0, 0)
      @param.init("luarw", TrueClass, "sglset", "sglget", 0, 0)
      @param.init("afact", Float, "sgrset", "sgrget", 0, 0)
      @param.init("const", Float, "sgrset", "sgrget", 0, 0)
      @param.init("constm", Float, "sgrset", "sgrget", 0, 0)
      @param.init("angle", Float, "sgrset", "sgrget", 0, 0)
      @param.init("latone", TrueClass, "sglset", "sglget", 0, 0)
      @param.init("iatone", TrueClass, "sglset", "sglget", 0, 0)
      @param.init("ffct", Float, "sgrset", "sgrget", 0, 0)
      
      @param.init("arrowtype", Fixnum, "sgslat", "sgqlat", 1, 1)
      @param.init("arrowindex", Fixnum, "sgslai", "sgqlai", 1, 1)

      @temp_param = @param.dup
      @backup = @param.dup
    end
    
    private :param_init

#------------------- method for parameters----------------------

    def set(key, val)
      @param[key] = val
    end

    def get(key)
      @param[key]
    end

#------------ draw method ----------------------

    def draw(x1, y1, x2, y2, temp=nil)
      Basics.checkundef(x2.to_f, y2.to_f)
      @param.sync
      @backup = @temp_param.set(temp, @param, @backup)
      @temp_param.sync

      Fig.settrf

      DCL.sglau(x1, y1, x2, y2)
      @backup.sync
      @temp_param.clear
    end

    def vdraw(x1, y1, x2, y2, temp=nil)
      @param.sync
      @backup = @temp_param.set(temp, @param, @backup)
      @temp_param.sync

      DCL.sglav(x1, y1, x2, y2)
      
      @backup.sync
      @temp_param.clear
    end

    module_function :param_init
    module_function :set
    module_function :get
    module_function :draw
    module_function :vdraw

    param_init

#----------------------------------------------------------

    @param.keys.each{|i|
      eval "def #{i}; @param['#{i}']; end"
      eval "def #{i}=(val); set('#{i}', val); end"
    }
  
    @param.keys.each{|i|
      eval "module_function :#{i}"
      eval "module_function :#{i}="
    }
  end
end
